我是靠谱客的博主 忐忑便当,最近开发中收集的这篇文章主要介绍POJ 3660-Cow Contest(最短路的变形),觉得挺不错的,现在分享给大家,希望可以做个参考。

概述





Cow Contest
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 14517 Accepted: 8137


题目链接:点击打开链接


Description

N (1 ≤ N ≤ 100) cows, conveniently numbered 1..N, are participating in a programming contest. As we all know, some cows code better than others. Each cow has a certain constant skill rating that is unique among the competitors.

The contest is conducted in several head-to-head rounds, each between two cows. If cow A has a greater skill level than cow B (1 ≤ A ≤ N; 1 ≤ B ≤ NA ≠ B), then cow A will always beat cow B.

Farmer John is trying to rank the cows by skill level. Given a list the results of M (1 ≤ M ≤ 4,500) two-cow rounds, determine the number of cows whose ranks can be precisely determined from the results. It is guaranteed that the results of the rounds will not be contradictory.

Input

* Line 1: Two space-separated integers: N and M
* Lines 2..M+1: Each line contains two space-separated integers that describe the competitors and results (the first integer, A, is the winner) of a single round of competition: A and B

Output

* Line 1: A single integer representing the number of cows whose ranks can be determined
 

Sample Input

5 5
4 3
4 2
3 2
1 2
2 5

Sample Output

2

题意:

有 n 头牛比赛,他们的编号分别从 1-n ,给出你 m 对关系,这 m 对关系里分别有两个数 A 和 B,代表 A 能赢 B ,让你判断从这 m 个关系里,有多少头牛的名次是可以被确定的。


分析:

首先我们要知道,想要确定某头牛的名次,一定要知道它和其他牛的关系,本题是一个最短路的变形,我们可以先将任意两个人之间的关系刷为无穷大,然后 s[i][j]=1 表示的是 i 能赢 j ,s[i][j]=-1 表示的是 i 不能赢 j ,所以只要给出的关系中能让我们找到 A 牛与其他所有牛的关系,那么 A 牛的名次就是确定的,为什么说它是最短路的变形呢,因为我们可以用弗洛伊德的思想来更新牛与牛之间的关系,代码中细看吧,哈哈哈哈#########


#include <iostream>
#include<stdio.h>
#include<string>
#include<string.h>
#include<math.h>
using namespace std;
#define INF 0x3f3f3f3f
int main()
{
int s[105][105];
int n,m;
int a,b;
scanf("%d %d",&n,&m);
memset(s,INF,sizeof(s));///初始将所有牛之间的关系都刷为无穷
for(int i=0;i<m;i++)
{
scanf("%d %d",&a,&b);
s[a][b]=1;///a能赢b
s[b][a]=-1;///b不能赢a
}
for(int k=1;k<=n;k++)
{
for(int i=1;i<=n;i++)
{
for(int j=1;j<=n;j++)
{
if(s[i][k]==s[k][j]&&s[i][k]!=INF)///通过一个中介点来更新其他两头牛之间的关系
s[i][j]=s[i][k];
}
}
}
int ans=0,sum=0;///ans是统计能确定名次的牛的个数
for(int i=1;i<=n;i++)
{
sum=0;///sum是用来统计编号为i的牛能与多少头牛确定关系
for(int j=1;j<=n;j++)
{
if(s[i][j]!=INF)
sum++;
}
if(sum==n-1)
ans++;
}
printf("%dn",ans);
return 0;
}












最后

以上就是忐忑便当为你收集整理的POJ 3660-Cow Contest(最短路的变形)的全部内容,希望文章能够帮你解决POJ 3660-Cow Contest(最短路的变形)所遇到的程序开发问题。

如果觉得靠谱客网站的内容还不错,欢迎将靠谱客网站推荐给程序员好友。

本图文内容来源于网友提供,作为学习参考使用,或来自网络收集整理,版权属于原作者所有。
点赞(50)

评论列表共有 0 条评论

立即
投稿
返回
顶部